searchNodes=[{"doc":"A resource that allows us to query an Account from Alpaca","ref":"Alpaca.Account.html","title":"Alpaca.Account","type":"module"},{"doc":"Retrieve your Alpaca trading account infoExample iex&gt; {:ok, %{} = account} = Alpaca.Account.get()Allows us to retrieve our own account information as a result tuple {:ok, %{}} if successful. If not success we will get back a result tuple {:error, {status: http_status_code, body: http_response_body}}","ref":"Alpaca.Account.html#get/0","title":"Alpaca.Account.get/0","type":"function"},{"doc":"A resource that allows us to perform operations on an Account ActivityAn account activity has the following methods we can call on itget/1 list/1The get/1 method allows us to get a singular account activity by calling Alpaca.Account.Activity.get(activity_type). Where activity_type is the type of activity you want to retrieve information for.The list/1 method allows us to list all account activities by calling Alpaca.Account.Activity.list(params). Where the params is a map, and in this case takes only one param which is activity_types. A comma separated string of activities types","ref":"Alpaca.Account.Activity.html","title":"Alpaca.Account.Activity","type":"module"},{"doc":"A function to get a singlular resource from the Alpaca API","ref":"Alpaca.Account.Activity.html#get/2","title":"Alpaca.Account.Activity.get/2","type":"function"},{"doc":"A function to list all resources from the Alpaca API","ref":"Alpaca.Account.Activity.html#list/1","title":"Alpaca.Account.Activity.list/1","type":"function"},{"doc":"A resource that allows us to query an Account Configuration from Alpaca","ref":"Alpaca.Account.Configuration.html","title":"Alpaca.Account.Configuration","type":"module"},{"doc":"Edit your Alpaca trading account configuration infoExample iex&gt; {:ok, %{} = account_config} = Alpaca.Account.Configuration.edit(%{trade_confirm_email: &quot;none&quot;})Allows us to edit our own account configuration info and return the new configuration as a result tuple {:ok, %{}} if successful. If not success we will get back a result tuple {:error, {status: http_status_code, body: http_response_body}}","ref":"Alpaca.Account.Configuration.html#edit/1","title":"Alpaca.Account.Configuration.edit/1","type":"function"},{"doc":"Retrieve your Alpaca trading account configuration infoExample iex&gt; {:ok, %{} = account_config} = Alpaca.Account.Configuration.get()Allows us to retrieve our own account configuration info as a result tuple {:ok, %{}} if successful. If not success we will get back a result tuple {:error, {status: http_status_code, body: http_response_body}}","ref":"Alpaca.Account.Configuration.html#get/0","title":"Alpaca.Account.Configuration.get/0","type":"function"},{"doc":"A resource that allows us to perform operations on an Account portfolio historyAn account portfolio history has the following methods we can call on itlist/1The list/1 method allows us to list all account portolio history by calling Alpaca.Account.Portfolio.History.list(params). Where the params is a map of query params defined by the Alpaca API documentation.","ref":"Alpaca.Account.Portfolio.History.html","title":"Alpaca.Account.Portfolio.History","type":"module"},{"doc":"A function to list all resources from the Alpaca API","ref":"Alpaca.Account.Portfolio.History.html#list/1","title":"Alpaca.Account.Portfolio.History.list/1","type":"function"},{"doc":"A function to update an existing resource using the Alpaca API","ref":"Alpaca.Account.Portfolio.History.html#update/2","title":"Alpaca.Account.Portfolio.History.update/2","type":"function"},{"doc":"A resource that allows us to perform operations on an AssetAn asset has the following methods we can call on itget/1 list/1The get/1 method allows us to get a singular asset by calling Alpaca.Asset.get(symbol) or Alpaca.Asset.get(id). Where symbol is the symbol of the asset to get and id is the Alpaca internal id of the asset.The list/1 method allows us to list all assets by calling Alpaca.Asset.list(params). Where the params are a map, and possible options are defined in the Alpaca documentation.","ref":"Alpaca.Asset.html","title":"Alpaca.Asset","type":"module"},{"doc":"A function to get a singlular resource from the Alpaca API","ref":"Alpaca.Asset.html#get/2","title":"Alpaca.Asset.get/2","type":"function"},{"doc":"A function to list all resources from the Alpaca API","ref":"Alpaca.Asset.html#list/1","title":"Alpaca.Asset.list/1","type":"function"},{"doc":"A resource that allows us to query the Bars data from Alpaca The bars API provides time-aggregated price and volume data.","ref":"Alpaca.Bars.html","title":"Alpaca.Bars","type":"module"},{"doc":"Retrieves a list of bars for each requested symbol. It is guaranteed all bars are in ascending order by time.Example iex&gt; {:ok, bars} = Alpaca.Bar.list(&quot;day&quot;, %{symbols: &quot;APPL,F,TSLA&quot;})Allows us to retrieve bars information as a result tuple {:ok, %{}} if successful. If not success we will get back a result tuple {:error, {status: http_status_code, body: http_response_body}}","ref":"Alpaca.Bars.html#list/2","title":"Alpaca.Bars.list/2","type":"function"},{"doc":"A resource that allows us to perform operations on an CalendarAn calendar has the following methods we can call on itlist/1The list/1 method allows us to serve the full list of market days from 1970 to 2029. It can also be queried by specifying a start and/or end time to narrow down the results. In addition to the dates, the response also contains the specific open and close times for the market days, taking into account early closures.You can pass optional start and/or end dates as params to the function to get specific time ranges like so Alpaca.Calendar.list(%{start: ~D[2020-02-10], end: ~D[2020-03-01]})","ref":"Alpaca.Calendar.html","title":"Alpaca.Calendar","type":"module"},{"doc":"A function to list all resources from the Alpaca API","ref":"Alpaca.Calendar.html#list/1","title":"Alpaca.Calendar.list/1","type":"function"},{"doc":"Client responsible for making requests to Alpaca and handling the responses.This client allows us to define all of our HTTP request logic and configuration in one place so that we can easily change or adapt this away from all of the other business logic of our library.We have access to HTTP request types on this client and it will automatically use a base url as well as set all the necessary headers for us.We have access to GET, POST, PATCH, and DELETE HTTP requests using this client.Example usageAlpaca.Client.get(&quot;/path&quot;, %{query_param: &quot;value&quot;}) Alpaca.Client.post(&quot;/path&quot;, %{param1: &quot;value&quot;}) Alpaca.Client.patch(&quot;/path&quot;, %{param1: &quot;value&quot;}) Alpaca.Client.delete(&quot;/path&quot;)","ref":"Alpaca.Client.html","title":"Alpaca.Client","type":"module"},{"doc":"","ref":"Alpaca.Client.html#api_host/0","title":"Alpaca.Client.api_host/0","type":"function"},{"doc":"","ref":"Alpaca.Client.html#client_id/1","title":"Alpaca.Client.client_id/1","type":"function"},{"doc":"","ref":"Alpaca.Client.html#client_secret/1","title":"Alpaca.Client.client_secret/1","type":"function"},{"doc":"","ref":"Alpaca.Client.html#data_api_host/0","title":"Alpaca.Client.data_api_host/0","type":"function"},{"doc":"Issue a delete request using the HTTP clientAccepts path which is the url path of the request, will be added to the end of the base_url","ref":"Alpaca.Client.html#delete/2","title":"Alpaca.Client.delete/2","type":"function"},{"doc":"Issue a get request using the HTTP clientAccepts path which is the url path of the request, will be added to the end of the base_url and a map of params which will become the query list for the get request","ref":"Alpaca.Client.html#get/3","title":"Alpaca.Client.get/3","type":"function"},{"doc":"Issue a patch request using the HTTP clientAccepts path which is the url path of the request, will be added to the end of the base_url and a map of params which will be the body of the post request","ref":"Alpaca.Client.html#patch/3","title":"Alpaca.Client.patch/3","type":"function"},{"doc":"Issue a post request using the HTTP clientAccepts path which is the url path of the request, will be added to the end of the base_url and a map of params which will be the body of the post request","ref":"Alpaca.Client.html#post/3","title":"Alpaca.Client.post/3","type":"function"},{"doc":"Issue a put request using the HTTP clientAccepts path which is the url path of the request, will be added to the end of the base_url and a map of params which will be the body of the post request","ref":"Alpaca.Client.html#put/3","title":"Alpaca.Client.put/3","type":"function"},{"doc":"A resource that allows us to perform operations on an clockAn clock has the following methods we can call on itget/0The get/0 method allows us to serve the current market timestamp, whether or not the market is currently open, as well as the times of the next market open and close.You can call it like so Alpaca.Clock.get()","ref":"Alpaca.Clock.html","title":"Alpaca.Clock","type":"module"},{"doc":"Retrieve the clock information nowExample iex&gt; {:ok, %{timestamp: timestamp, is_open: is_open, next_open: next_open, next_close: next_close} = clock} = Alpaca.Clock.get()Allows us to serve the current market timestamp, whether or not the market is currently open, as well as the times of the next market open and close.","ref":"Alpaca.Clock.html#get/0","title":"Alpaca.Clock.get/0","type":"function"},{"doc":"A resource that allows us to query for the last quote details for a symbolA last quote has the following methods we can call on itget/1The get/1 method allows us to get a singular last quote for a given symbol by calling Alpaca.Last.Quote.get(symbol). Where symbol is the stock symbol you want to retrieve last quote information for.","ref":"Alpaca.Last.Quote.html","title":"Alpaca.Last.Quote","type":"module"},{"doc":"A function to get a singlular resource from the Alpaca API","ref":"Alpaca.Last.Quote.html#get/2","title":"Alpaca.Last.Quote.get/2","type":"function"},{"doc":"A resource that allows us to query for the last trade of a symbolA last trade has the following methods we can call on itget/1The get/1 method allows us to get a singular last trade for a given symbol by calling Alpaca.Last.Trade.get(symbol). Where symbol is the stock symbol you want to retrieve last trade information for.","ref":"Alpaca.Last.Trade.html","title":"Alpaca.Last.Trade","type":"module"},{"doc":"A function to get a singlular resource from the Alpaca API","ref":"Alpaca.Last.Trade.html#get/2","title":"Alpaca.Last.Trade.get/2","type":"function"},{"doc":"A resource that allows us to perform operations on an OrderAn order has the following methods we can call on itget/1 list/1 create/1 edit/2 delete_all/0 delete/1 get_by_client_order_id/1The get/1 method allows us to get a singular order by calling Alpaca.Order.get(id). Where id is the id of the order to get.The list/1 method allows us to list all orders by calling Alpaca.Order.list(params). Where params is a Map of optional params you can use to retrieve orders defined in the Alpaca API documentationThe create/1 method allows us to create a new order by calling Alpaca.Order.create(params). Where params is the Map of parameters to create the orderThe edit/2 method allows us to edit a specific order by calling Alpaca.Order.edit(id, params). Where id is the id of the order and params are the parameters of the order we want to change defined by the Alpaca API documentation.The delete_all/0 method allows us to delete all open orders by calling Alpaca.Order.delete_all().The delete/1 method allows us to delete a specific order by calling Alpaca.Order.delete(id). Where id is the id of the order we want to delete.The get_by_client_order_id/1 method allows us to get a specific order by the client order id by calling Alpaca.Order.get_by_client_order_id(client_order_id). Where client_order_id is the client order id on the order.","ref":"Alpaca.Order.html","title":"Alpaca.Order","type":"module"},{"doc":"A function to create a new resource from the Alpaca API","ref":"Alpaca.Order.html#create/1","title":"Alpaca.Order.create/1","type":"function"},{"doc":"A function to delete a singular resource of a given type using the Alpaca API","ref":"Alpaca.Order.html#delete/1","title":"Alpaca.Order.delete/1","type":"function"},{"doc":"A function to delete all resources of a given type using the Alpaca API","ref":"Alpaca.Order.html#delete_all/0","title":"Alpaca.Order.delete_all/0","type":"function"},{"doc":"A function to edit an existing resource using the Alpaca API","ref":"Alpaca.Order.html#edit/2","title":"Alpaca.Order.edit/2","type":"function"},{"doc":"A function to get a singlular resource from the Alpaca API","ref":"Alpaca.Order.html#get/2","title":"Alpaca.Order.get/2","type":"function"},{"doc":"Retrieve an order by client order idExample iex&gt; {:ok, %{} = order} = Alpaca.Order.get_by_client_order_id(client_order_id)Allows us to retrieve our an order as a result tuple {:ok, %{}} if successful. If not success we will get back a result tuple {:error, {status: http_status_code, body: http_response_body}}","ref":"Alpaca.Order.html#get_by_client_order_id/1","title":"Alpaca.Order.get_by_client_order_id/1","type":"function"},{"doc":"A function to list all resources from the Alpaca API","ref":"Alpaca.Order.html#list/1","title":"Alpaca.Order.list/1","type":"function"},{"doc":"A resource that allows us to perform operations on an PositionA position has the following methods we can call on itget/1 list/0 delete_all/0 delete/1The get/1 method allows us to get a singular position by calling Alpaca.Position.get(symbol). Where symbol is the symbol of the position to get.The list/1 method allows us to list all positions by calling Alpaca.Position.list().The delete_all/0 method allows us to close all open positions by calling Alpaca.Position.delete_all().The delete/1 method allows us to close a specific position by calling Alpaca.Position.delete(symbol). Where symbol is the symbol of the position we want to close.","ref":"Alpaca.Position.html","title":"Alpaca.Position","type":"module"},{"doc":"A function to delete a singular resource of a given type using the Alpaca API","ref":"Alpaca.Position.html#delete/1","title":"Alpaca.Position.delete/1","type":"function"},{"doc":"A function to delete all resources of a given type using the Alpaca API","ref":"Alpaca.Position.html#delete_all/0","title":"Alpaca.Position.delete_all/0","type":"function"},{"doc":"A function to get a singlular resource from the Alpaca API","ref":"Alpaca.Position.html#get/2","title":"Alpaca.Position.get/2","type":"function"},{"doc":"A function to list all resources from the Alpaca API","ref":"Alpaca.Position.html#list/1","title":"Alpaca.Position.list/1","type":"function"},{"doc":"This module uses a macro to allow us to easily create the base HTTP methods for an Alpaca Resource. Most Alpaca requests have a common set of methods to get a specific resource by ID, list all resources, update the resource, delete all resources and delete a resource by id. By using this macro we can easily build out new API endpoints in a single line of code.Exampledefmodule Alpaca.NewResource do use Alpaca.Resource, endpoint: &quot;new_resources&quot; endWe that single line of code we will now have a list/0, list/1, get/1, get/2, create/1, edit/2, delete_all/0, and delete/1 functions for a given resource.You can also exclude functions from being created by passing them as a list of atoms with the :exclude keyword in the resource definition.Exampledefmodule Alpaca.NewResource do use Alpaca.Resource, endpoint: &quot;new_resources&quot;, exclude: [:delete_all, :delete] endThis definition will not create a delete_all/0 or delete/1 endpoint for the new resource you have defined.","ref":"Alpaca.Resource.html","title":"Alpaca.Resource","type":"module"},{"doc":"This middleware handles responses from the Alpaca API and returns it in a result tuple of either {:ok, reponse_body} or {:error, error_message}.This allows us to easily handle all of our responses in a uniform way.Example usagedefmodule Alpaca.Client do use Tesla plug Alpaca.ResponseMiddleware endOptionsThere are no options at the current moment in time","ref":"Alpaca.ResponseMiddleware.html","title":"Alpaca.ResponseMiddleware","type":"module"},{"doc":"Callback implementation for Tesla.Middleware.call/3.","ref":"Alpaca.ResponseMiddleware.html#call/3","title":"Alpaca.ResponseMiddleware.call/3","type":"function"},{"doc":"The Alpaca.Stream module handles negotiating the connection, then sending frames, receiving frames, closing, and reconnecting that connection for the websocket streaming API of Alpaca. A simple client implementation would be:defmodule AlpacaStreamClient do use Alpaca.Stream, url: &quot;https://paper-api.alpaca.markets/stream&quot; def start_link() do start_link([&quot;account_updates&quot;, &quot;trade_updates&quot;]) end @impl Alpaca.Stream def handle_msg(msg, state) do IO.puts &quot;Received a message: \#{msg}&quot; {:ok, state} end endThe url keyword is optional and if omitted will be defaulted to &quot;\#{Client.api_host()}/stream&quot; to key backwards compatibility.SupervisionAlpaca.Stream uses WebSockex under the hoodWebSockex is implemented as an OTP Special Process and as a result will fit into supervision trees. WebSockex also supports the Supervisor children format introduced in Elixir 1.5. Meaning that a child specification could be {ClientModule, [state]}. However, since there is a possibility that you would like to provide a t:WebSockex.Conn/0 or a url as well as the state, there are two versions of the child_spec function. If you need functionality beyond that it is recommended that you override the function or define your own. Just remember to use the version that corresponds with your start_link's arity.","ref":"Alpaca.Stream.html","title":"Alpaca.Stream","type":"behaviour"},{"doc":"Define how we want to handle the messages we receive from the websocket You can expect them to be a map since we will decode them from a binary to a json.Exampledefmodule TestStream do use Alpaca.Stream, url: &quot;wss://data.alpaca.markets/stream&quot; @impl Alpaca.Stream def handle_msg(msg, state) do IO.puts &quot;Received a message: \#{inspect(msg)}&quot; {:ok, state} end end","ref":"Alpaca.Stream.html#c:handle_msg/2","title":"Alpaca.Stream.handle_msg/2","type":"callback"},{"doc":"A resource that allows us to perform operations on an WatchlistA watchlist has the following methods we can call on itget/1 list/0 create/1 update/2 add_asset/2 remove_asset/2 delete/1The get/1 method allows us to get a singular watchlist by calling Alpaca.Watchlist.get(id). Where id is the id of the watchlist to get.The list/0 method allows us to list all watchlists by calling Alpaca.Watchlist.list().The create/1 method allows us to create a new watchlist by calling Alpaca.Watchlist.create(params). Where params is the Map of parameters to create the watchlistThe update/2 method allows us to update a specific watchlist by calling Alpaca.Watchlist.update(id, params). Where id is the id of the watchlist and params are the parameters of the watchlist we want to update defined by the Alpaca API documentation.The add_asset/2 method allows us to add an asset to a specific watchlist by calling Alpaca.Watchlist.add_asset(id, params). Where id is the id of the watchlist and params are the parameters of the asset to add. At this time just a key symbol is needed.The remove_asset/2 method allows us to remove an asset from a specific watchlist by calling Alpaca.Watchlist.remove_asset(id, symbol). Where id is the id of the watchlist and symbol is the symbol to removeThe delete/1 method allows us to delete a specific watchlist by calling Alpaca.Watchlist.delete(id). Where id is the id of the order we want to delete.","ref":"Alpaca.Watchlist.html","title":"Alpaca.Watchlist","type":"module"},{"doc":"Adds an asset to a watchlistExample iex&gt; {:ok, %{} = watchlist} = Alpaca.Watchlist.add_asset(id, %{symbol: symbol})Allows us to add an asset to a watchlist and get back a a result tuple {:ok, %{}} if successful. If not success we will get back a result tuple {:error, {status: http_status_code, body: http_response_body}}","ref":"Alpaca.Watchlist.html#add_asset/2","title":"Alpaca.Watchlist.add_asset/2","type":"function"},{"doc":"A function to create a new resource from the Alpaca API","ref":"Alpaca.Watchlist.html#create/1","title":"Alpaca.Watchlist.create/1","type":"function"},{"doc":"A function to delete a singular resource of a given type using the Alpaca API","ref":"Alpaca.Watchlist.html#delete/1","title":"Alpaca.Watchlist.delete/1","type":"function"},{"doc":"A function to get a singlular resource from the Alpaca API","ref":"Alpaca.Watchlist.html#get/2","title":"Alpaca.Watchlist.get/2","type":"function"},{"doc":"A function to list all resources from the Alpaca API","ref":"Alpaca.Watchlist.html#list/1","title":"Alpaca.Watchlist.list/1","type":"function"},{"doc":"Remove an asset from a watchlistExample iex&gt; {:ok, %{} = watchlist} = Alpaca.Watchlist.remove_asset(id, symbol)Allows us to remove an asset from a watchlist and get back a a result tuple {:ok, %{}} if successful. If not success we will get back a result tuple {:error, {status: http_status_code, body: http_response_body}}","ref":"Alpaca.Watchlist.html#remove_asset/2","title":"Alpaca.Watchlist.remove_asset/2","type":"function"},{"doc":"A function to update an existing resource using the Alpaca API","ref":"Alpaca.Watchlist.html#update/2","title":"Alpaca.Watchlist.update/2","type":"function"},{"doc":"An Elixir wrapper for the Alpaca stock trading API.","ref":"AlpacaElixir.html","title":"AlpacaElixir","type":"module"},{"doc":"Exception for when a request is made without a Client ID and Secret.","ref":"Alpaca.Client.MissingCredentialsError.html","title":"Alpaca.Client.MissingCredentialsError","type":"exception"}]